#ifndef A232
#define A232

#include "../include/baud_rate_calcs.h"

; This file is meant to be included by other files that want to
; use 232 sending and receiving.
;
; T1IN and R1OUT are defined to the appropriate pins.

	SEGU data

charbuf DS 1
bitcount DS 1

	SEG code

;--------------
; UART_TX
;
; sends 8 bits over the 232 link, byte should be in W
;
UART_232_TX
	movwf	charbuf
    movlw   9
    movwf   bitcount
    bcf     STATUS,C
    goto    out232start
out232bit
    rrf     charbuf,F
out232start
    btfss   STATUS,C
    bcf     T1IN
    btfsc   STATUS,C
    bsf     T1IN
    movlw   DELAYBAUD
    call    delaybit 
    decfsz  bitcount,F
    goto    out232bit   
    bsf     T1IN
    movlw   DELAYBAUD
    call    delaybit 
    return

;--------------
; UART_232_RX
;
; receives 8 bits over the 232 link, result in charbuf
;
UART_232_RX
    movlw   8
    movwf   bitcount
    clrf    charbuf
in232wait
    nop
    btfsc   R1OUT
    retlw	1
    movlw   DELAYHALFBAUD
    call    delayhalfbit 
    btfsc   R1OUT
    goto    in232wait
in232loop1
    movlw   DELAYBAUD
    call    delaybit 
    btfss   R1OUT
    bcf     STATUS,C
    btfsc   R1OUT
    bsf     STATUS,C
    rrf     charbuf,F  
    decfsz  bitcount,F
    goto    in232loop1   
    retlw 0

#include "../include/delay.asm"



#endif
