#ifndef A485
#define A485

#include "baud_rate_calcs.h"


; This file is meant to be included by other files that want to
; use 485 sending and receiving.
;
; It assumes that you have a variable defined called 'bitcount' and that RE_DE, DI,
; and RO are defined to the appropriate pins.

;--------------
; UART_TX
;
; sends 8 bits over the 485 link, byte should be in W
;
UART_TX
	movwf	charbuf
    movlw   9
    movwf   bitcount
    bcf     STATUS,C
    bsf     DE_RE   
    goto    outstart
outbit
    rrf     charbuf,F
outstart
    btfss   STATUS,C
    bcf     DI
    btfsc   STATUS,C
    bsf     DI
    movlw   DELAYBAUD
    call    delaybit 
    decfsz  bitcount 
    goto    outbit   
    bsf     DI
    movlw   DELAYBAUD
    call    delaybit 
    bcf     DE_RE    
    return

;--------------
; UART_RX
;
; receives 8 bits over the 485 link, result in charbuf
;
UART_RX
    movlw   8
    movwf   bitcount
    bcf     DE_RE   ; receive enable when low
    clrf    charbuf
inwait
    nop
    btfsc   RO
    retlw	1
    movlw   DELAYHALFBAUD
    call    delayhalfbit 
    btfsc   RO
    goto    inwait
inloop1
    movlw   DELAYBAUD
    call    delaybit 
    btfss   RO
    bcf     STATUS,C
    btfsc   RO
    bsf     STATUS,C
    rrf     charbuf,F  
    decfsz  bitcount,F
    goto    inloop1   
    
    movlw	DELAYBAUD
    call	delaybit
    retlw 0

#include "delay.asm"



#endif
