; bin2bcd.asm
;
; routine for the conversion from binary to bcd
;
; Code Space: 32 bytes
; Data Space: 6 bytes

#ifndef BIN2BCD_ASM
#define BIN2BCD_ASM

	SEGU data
	
bcd1 DS 1
bcd2 DS 1
bcd3 DS 1
bin1 DS 1
bin2 DS 1
bcd_cnt DS 1

	SEG code

; takes a 16 bit number in bin1 and bin2 with bin1 having the msbs
; and converts it into bcd in locations bcd1 bcd2, & bcd3
bin2bcd
    movlw   16
    movwf   bcd_cnt
    clrf    bcd1   
    clrf    bcd2   
    clrf    bcd3   
    goto    bcd_start

adjdec
    movlw   0x33
    addwf   bcd1,F
    addwf   bcd2,F
    addwf   bcd3,F
    
    movlw   0x03
    btfss   bcd1,3
     subwf  bcd1,F
    btfss   bcd2,3
     subwf  bcd2,F
    btfss   bcd3,3
     subwf  bcd3,F
    
    movlw   0x30
    btfss   bcd1,7
     subwf  bcd1,F
    btfss   bcd2,7
     subwf  bcd2,F
    btfss   bcd3,7
     subwf  bcd3,F

bcd_start
    rlf     bin2,F
    rlf     bin1,F
    rlf     bcd3,F
    rlf     bcd2,F
    rlf     bcd1,F
    decfsz  bcd_cnt,F
     goto   adjdec   
    
    return

#endif
