#ifndef DIV16X18
#define DIV16X18

;*************************************************************************
; DIV8 -- Divide a 16 bit by 8 bit
;         Result MUST fit in 8 bits, otherwise erroneous result.
;         110 clock cycles.
;         {DATA_HI, DATA_LO} / DVSR_LO -> 
;     Quocient --> Stored in data_lo
;     Remainder --> Stored in data_hi
;*************************************************************************

	SEGU data
	
data_hi DS 1
data_lo DS 1
dvsr_lo DS 1
tmp_lo DS 1

	SEG code
	
DIV8
    movlw   8
    movwf   temp
    bcf     STATUS, C       ;Clear Carry bitM
    clrf    tmp_lo
div_loop
    rlf     data_lo, F
    rlf     data_hi, F
    rlf     tmp_lo, F               ;save "borrow"
    movf    dvsr_lo, W  
    subwf   data_hi, W  
    btfss   tmp_lo, 0               ;Save result if borrow is 1
    ;SKPNC                          ;Else, save only if positive
    btfsc   STATUS, C       ;Skip if not carry
    movwf   data_hi
    btfsc   tmp_lo, 0               ;Make sure carry is a 1 if
    rrf     tmp_lo, F               ;borrow is 1  
    decfsz  temp, F 
    goto    div_loop
    rlf     data_lo, F              ;quotient in DATA_LO  M
div_exit                                ;remainder in DATA_HI  M
    return

#endif
	